Unit AFP7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP7R(var A :Array of Real; N :Integer; M :Integer);

implementation

procedure AFP7R(var A :Array of Real; N :Integer; M :Integer);
var
I,J,K,L,LL :Integer;
R1,R2,R,P,T,C,S,A1,A2 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
for K:=1 to N do
 begin
  L := K+1;
  if ( L > M ) 
   then goto _8;
  for J:=L to M do
   begin
    R2 := A[(K-1)+(J-1)*N];
    if ( R2 = 0.0 ) 
     then goto _7;
    R1 := A[(K-1)+(K-1)*N];
    A1 := Abs(R1);
    A2 := Abs(R2);
    if ( A1 <> 0.0 ) 
     then goto _1;
    T := 1;
    A[(K-1)+(K-1)*N] := A[(K-1)+(J-1)*N];
    goto _5;
_1:
    if ( A1 <= A2 ) 
     then goto _2;
    P := R2/R1;
    R := Sqrt(1.0+P*P);
    T := P/(R+1.0);
    A[(K-1)+(K-1)*N] := R*R1;
    goto _5;
_2:
    P := R1/R2;
    R := Sqrt(1.0+P*P);
    T := 1.0/(R+Abs(P));
    if ( P < 0.0 ) 
     then T := -T;
    if ( R1 ) < 0
     then goto _3
     else if ( R1 ) > 0
           then goto _4
           else goto _4;
_3:
    A[(K-1)+(K-1)*N] := -R*A2;
    goto _5;
_4:
    A[(K-1)+(K-1)*N] := R*A2;
_5:
    A[(K-1)+(J-1)*N] := T;
    R := T*T;
    R1 := 1.0/(1.0+R);
    C := (1.0-R)*R1;
    S := (T+T)*R1;
    if ( L > N ) 
     then goto _7;
    for I:=L to N do
     begin
      R1 := A[(I-1)+(K-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(I-1)+(K-1)*N] := R1*C+R2*S;
      A[(I-1)+(J-1)*N] := R2*C-R1*S;
_6:
     end;
_7:
   end;
_8:
  LL := L+1;
  if ( LL > N ) 
   then goto _16;
  for I:=LL to N do
   begin
    R2 := A[(I-1)+(K-1)*N];
    if ( R2 = 0.0 ) 
     then goto _15;
    R1 := A[(L-1)+(K-1)*N];
    A1 := Abs(R1);
    A2 := Abs(R2);
    if ( A1 <> 0.0 ) 
     then goto _9;
    T := 1;
    A[(L-1)+(K-1)*N] := -A[(I-1)+(K-1)*N];
    goto _13;
_9:
    if ( A1 <= A2 ) 
     then goto _10;
    P := -R2/R1;
    R := Sqrt(1.0+P*P);
    T := P/(R+1.0);
    A[(L-1)+(K-1)*N] := R1*R;
    goto _13;
_10:
    P := -R1/R2;
    R := Sqrt(1.0+P*P);
    T := 1.0/(R+Abs(P));
    if ( P < 0.0 ) 
     then T := -T;
    if ( R1 ) < 0
     then goto _11
     else if ( R1 ) > 0
           then goto _12
           else goto _12;
_11:
    A[(L-1)+(K-1)*N] := -A2*R;
    goto _13;
_12:
    A[(L-1)+(K-1)*N] := A2*R;
_13:
    A[(I-1)+(K-1)*N] := T;
    R := T*T;
    R1 := 1.0/(1.0+R);
    C := (1.0-R)*R1;
    S := (T+T)*R1;
    if ( L > M ) 
     then goto _15;
    for J:=L to M do
     begin
      R1 := A[(L-1)+(J-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(L-1)+(J-1)*N] := C*R1-S*R2;
      A[(I-1)+(J-1)*N] := S*R1+C*R2;
_14:
     end;
_15:
   end;
_16:
 end;
end;

end.
